<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Str;
use GuzzleHttp\Client;
use App\Http\Controllers\GuzzleHttp\RequestOptions;

class ApiController extends Controller
{

    public function __construct()
    {
        $this->cities = getDestinations();
    }
    public function index()
    {

        return view('welcome', ['cities' => $this->cities, 'origin_city_name' => '', 'destination_city_name' => '']);
    }

    public function searchBusShedule(Request $request)
    {

        $request->validate([
            'origin' => 'required',
            'destination' => 'required',
            'departure' => 'required'
        ]);
        // $this->cities = getDestinations();
        $origin_city_name = getCity($request->origin);
        $destination_city_name = getCity($request->destination);
        echo  $request->origin . "<br>";
        echo  $request->destination;

        $req = Http::get("http://apistaging.ticketsimply.com/gds/api/schedules/" . $request->origin . "/" . $request->destination . "/" . $request->departure . ".json?api_key=TSVEMBAPI72461260");

        $response = json_decode($req->getBody()->getContents());;
        $i = 0;
        $j = 0;
        $keys = [];
        $values = [];
        $returnList = [];
        foreach ($response as  $k => $value) {
            if ($k == 'response') {
                return view('bus-list', ['data' => '', 'returnList' => ' ', 'message' => 'No services found with the requested data.', 'cities' => $this->cities, 'origin_city_name' => $origin_city_name, 'destination_city_name' => $destination_city_name]);
            } elseif (($k != 'result') && ($k != 'response')) {
                $i = 0;
                $j = 1;
                foreach ($value as  $key => $val) {
                    $values[$j][$k][$i] =  $val;
                    $i++;
                }
                $j++;
            } else {
                $lim = count((array)$value);
                foreach ($value as  $key => $val) {

                    $limit = count((array)$val);
                    if ($j < $lim) {
                        for ($i = 0; $i < $limit; $i++) {
                            if ($j == 0) {
                                $keys[$i] = $val[$i];
                            } else {
                                $values[$j][$keys[$i]] = $val[$i];
                            }
                        }
                        $j++;
                    }
                }
            }
        }
        // print_r($values);

        if ($request->return) {

            $req = Http::get("http://apistaging.ticketsimply.com/gds/api/schedules/" . $request->destination . "/" . $request->origin . "/" . $request->return . ".json?api_key=TSVEMBAPI72461260");
            $response = json_decode($req->getBody()->getContents());
            $i = 0;
            $j = 0;
            $keys = [];

            foreach ($response as  $k => $value) {
                if ($k == 'response') {
                    return view('bus-list', ['data' => $values, 'returnList' => $returnList, 'message' => 'No services found with the requested data.', 'cities' => $this->cities, 'origin_city_name' => $origin_city_name, 'destination_city_name' => $destination_city_name]);
                } elseif (($k != 'result') && ($k != 'response')) {
                    $i = 0;
                    $j = 1;
                    foreach ($value as  $key => $val) {
                        $returnList[$j][$k][$i] =  $val;
                        $i++;
                    }
                    $j++;
                } else {
                    $lim = count((array)$value);
                    foreach ($value as  $key => $val) {

                        $limit = count((array)$val);
                        if ($j < $lim) {
                            for ($i = 0; $i < $limit; $i++) {
                                if ($j == 0) {
                                    $keys[$i] = $val[$i];
                                } else {
                                    $returnList[$j][$keys[$i]] = $val[$i];
                                }
                            }
                            $j++;
                        }
                    }
                }
            }
        }
        // echo "<br><br> ------------------------------------------<br>/<br>";
        // print_r($returnList);
        // die();
        return view('bus-list', ['data' => $values,  'returnList' => $returnList, 'message' => '', 'cities' => $this->cities, 'origin_city_name' => $origin_city_name, 'destination_city_name' => $destination_city_name]);
    }

    public function getDestination(Request $request)
    {
        $city_pairs = Http::get("http://apistaging.ticketsimply.com/gds/api/city_pairs.json?api_key=TSVEMBAPI72461260");
        $pair_response = json_decode($city_pairs->getBody()->getContents(), true);

        $dest = array();
        foreach ($pair_response['result'] as $k => $item) {
            if ($item[0] == $request->id) {
                $dest[] = $item[1];
            }
        }
        $collect =  collect($this->cities);
        $search = $collect->whereIn('id', $dest);
        $html = "";
        foreach ($search->all() as $item) {
            $html .= '<option value="' . $item['id'] . '"  data-tokens="' . $item['name'] . '">' . $item['name'] . '</option>';
        }
        return  response()->json(['html' => $html]);
        // return $search;
    }
}
